'' The RngStream-header, i.e., RngStream.h, of vers. 1.0. was translated to RngStream.bi for FreeBASIC/Linux by Hans L. Nemeschkal, 19-10-2006.
'' Hans.Leo.Nemeschkal@univie.ac.at
'' Department of Theoretical Biologie, University of Vienna, Althanstrasse 14, A-1090 Vienna, Austria, European Union
''
'' For more information on RngStreams see http://www.iro.umontreal.ca/~simardr/indexe.html or http://statmath.wu-wien.ac.at/software/RngStreams/
''
'' Please copy (1) the header RngStream.bi to \FreeBASIC\inc\
''        and  (2) the static library librngstreams.a to \FreeBASIC\lib\win32\
''



#ifndef RNGSTREAM_bi
#define RNGSTREAM_bi


'' to include the library librngstreams.a is necessary to compilation (linking)
'' - WinXX
'$inclib: "rngstreams"


type RngStream as RngStream_InfoState ptr

type RngStream_InfoState
	rngCg(6) as double
	rngBg(6) as double
	rngIg(6) as double
	rngAnti as integer
	rngIncPrec as integer
	rngname as byte ptr
end type


declare function RngStream_SetPackageSeed cdecl alias "RngStream_SetPackageSeed" (byval rngseed as uinteger ptr) as integer

declare function RngStream_CreateStream cdecl alias "RngStream_CreateStream" (byval rngname as byte ptr) as RngStream

declare sub RngStream_DeleteStream cdecl alias "RngStream_DeleteStream" (byval rngpg as RngStream ptr)

declare sub RngStream_ResetStartStream cdecl alias "RngStream_ResetStartStream" (byval rngg as RngStream)

declare sub RngStream_ResetStartSubstream cdecl alias "RngStream_ResetStartSubstream" (byval rngg as RngStream)

declare sub RngStream_ResetNextSubstream cdecl alias "RngStream_ResetNextSubstream" (byval rngg as RngStream)

declare sub RngStream_SetAntithetic cdecl alias "RngStream_SetAntithetic" (byval rngg as RngStream, byval gga as integer)

declare sub RngStream_IncreasedPrecis cdecl alias "RngStream_IncreasedPrecis" (byval rngg as RngStream, byval rngincp as integer)

declare function RngStream_SetSeed cdecl alias "RngStream_SetSeed" (byval rngg as RngStream, byval rngseed as uinteger ptr) as integer

declare sub RngStream_AdvanceState cdecl alias "RngStream_AdvanceState" (byval rngg as RngStream, byval gge as long, byval ggc as long)

declare sub RngStream_GetState cdecl alias "RngStream_GetState" (byval rngg as RngStream, byval rngseed as uinteger ptr)

declare sub RngStream_WriteState cdecl alias "RngStream_WriteState" (byval rngg as RngStream)

declare sub RngStream_WriteStateFull cdecl alias "RngStream_WriteStateFull" (byval rngg as RngStream)

declare function RngStream_RandU01 cdecl alias "RngStream_RandU01" (byval rngg as RngStream) as double

declare function RngStream_RandInt cdecl alias "RngStream_RandInt" (byval rngg as RngStream, byval iigi as integer, byval jigi as integer) as integer

'' note please that dimensioning of rngseed( ) is necessary !
DIM rngseed(6) as uinteger 

#endif