'' example-program for using RngStreams-routines via Freebasic/Linux
'' concerning the header of RngStreams-1.0.
''
'' program name 'rngexa1.bas' - for Linux, Unix  and WinXX
'' 19-10-2006
''
'' 
''
'' by Hans L. Nemeschkal, Department of Theoretical Biology, University of Vienna, Althanstrasse 14, A-1090 Vienna, Austria, European Union
''
'' Hans.Leo.Nemeschkal@univie.ac.at
''
''
''
'' compile with Freebasic as fbc -v rngexa1.bas
''
''
'' include the RngStreams-header - Freebasic/Linux or WinXX
'$include: "RngStream.bi"

COMMON SHARED x#(), gen as RngStream, gaz as integer
rem DIM rngseed(6) as uinteger
rem note please that dimensioning of rngseed() is already organized by the header RngStream.bi !
rem 
DIM cpag1 as byte ptr, cpag2 as byte ptr, cpag3 as byte ptr, cpag4 as byte ptr, cpag5 as byte ptr, cpag6 as byte ptr
DIM addr1 as uinteger ptr, addr2 as uinteger ptr, addr3 as uinteger ptr, addr4 as uinteger ptr, addr5 as uinteger ptr, addr6 as uinteger ptr
DIM zeitinit as uinteger
DIM x#(6)
pagf1$ = "generator_1"
pagf2$ = "generator_2"
pagf3$ = "generator_3"
pagf4$ = "generator_4"
pagf5$ = "generator_5"
pagf6$ = "generator_6"

rem stringpointers 
cpag1 = STRPTR(pagf1$)
cpag2 = STRPTR(pagf2$)
cpag3 = STRPTR(pagf3$)
cpag4 = STRPTR(pagf4$)
cpag5 = STRPTR(pagf5$)
cpag6 = STRPTR(pagf6$)

zeitinit = TIMER
print
print "initialization by the TIMER:"
print TIMER, zeitinit
print
rem ***** the limiting requirements  by RngStreams concerning the seed
for j = 1 to 3
	if zeitinit < 4294967087 then rngseed(j) = zeitinit
	if zeitinit >= 4294967087 then rngseed(j) = zeitinit/2
next j
for j = 4 to 6
	if zeitinit < 4294944443 then rngseed(j) = zeitinit
	if zeitinit >= 4294944443 then rngseed(j) = zeitinit/2
next j

xx = 1
rem *** variablepointer
addr1 = VARPTR(rngseed(xx))
CALL RngStream_SetPackageSeed (addr1)

gen1 = RngStream_CreateStream (cpag1)
gen2 = RngStream_CreateStream (cpag2)
gen3 = RngStream_CreateStream (cpag3)
gen4 = RngStream_CreateStream (cpag4)
gen5 = RngStream_CreateStream (cpag5)
gen6 = RngStream_CreateStream (cpag6)

print "random reals between 0 and 1:"
for i = 1 to 30
  x#(1) = RngStream_RandU01(gen1)
  x#(2) = RngStream_RandU01(gen2)
  x#(3) = RngStream_RandU01(gen3)
  x#(4) = RngStream_RandU01(gen4)
  x#(5) = RngStream_RandU01(gen5)
  x#(6) = RngStream_RandU01(gen6)

  print x#(1);x#(2); x#(3); x#(4); x#(5); x#(6)
next i
rem +++ random integers between loli_ and upli_
print
print "random integers:"
loli_1 = 1 :upli_1 = 10
loli_5 = -12 :upli_5 = 14
for i = 1 to 30
gaz1 = RngStream_RandInt (gen1, loli_1, upli_1)
gaz5 = RngStream_RandInt (gen5, loli_5, upli_5)
print gaz1, gaz5
next i
rngincp = 1
print
print "random reals between 0 and 1- increased precision:"
CALL RngStream_IncreasedPrecis(gen2, rngincp)
for i = 1 to 30
  x#(2) = RngStream_RandU01(gen2)
  print x#(2)
next i

gga = 1
rem set antithetic
print
print "random reals between 0 and 1 - antithetic:"
CALL RngStream_SetAntithetic (gen1, gga)
for i = 1 to 10
  x#(1) = RngStream_RandU01(gen1)
  x#(2) = RngStream_RandU01(gen2)
  x#(3) = RngStream_RandU01(gen3)
  x#(4) = RngStream_RandU01(gen4)
  x#(5) = RngStream_RandU01(gen5)
  x#(6) = RngStream_RandU01(gen6)

  print x#(1);x#(2); x#(3); x#(4); x#(5); x#(6)
next i

end
